
;CodeVisionAVR C Compiler V2.03.5 Evaluation
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega32
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 512 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.5 Evaluation
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 02.05.2010
;Author  : Freeware, for evaluation and non-commercial use only
;Company :
;Comments:
;
;
;Chip type           : ATmega32
;Program type        : Application
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;External RAM size   : 0
;Data Stack size     : 512
;*****************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;// Declare your global variables here
;
;void main(void)
; 0000 001D {

	.CSEG
_main:
; 0000 001E // Declare your local variables here
; 0000 001F 
; 0000 0020 // Input/Output Ports initialization
; 0000 0021 // Port A initialization
; 0000 0022 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0023 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0024 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0025 DDRA=0x00;
	OUT  0x1A,R30
; 0000 0026 
; 0000 0027 // Port B initialization
; 0000 0028 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0029 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 002A PORTB=0x00;
	OUT  0x18,R30
; 0000 002B DDRB=0x00;
	OUT  0x17,R30
; 0000 002C 
; 0000 002D // Port C initialization
; 0000 002E // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 002F // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0030 PORTC=0x00;
	OUT  0x15,R30
; 0000 0031 DDRC=0x00;
	OUT  0x14,R30
; 0000 0032 
; 0000 0033 // Port D initialization
; 0000 0034 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0035 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0036 PORTD=0x00;
	OUT  0x12,R30
; 0000 0037 DDRD=0x00;
	OUT  0x11,R30
; 0000 0038 
; 0000 0039 // Timer/Counter 0 initialization
; 0000 003A // Clock source: System Clock
; 0000 003B // Clock value: Timer 0 Stopped
; 0000 003C // Mode: Normal top=FFh
; 0000 003D // OC0 output: Disconnected
; 0000 003E TCCR0=0x00;
	OUT  0x33,R30
; 0000 003F TCNT0=0x00;
	OUT  0x32,R30
; 0000 0040 OCR0=0x00;
	OUT  0x3C,R30
; 0000 0041 
; 0000 0042 // Timer/Counter 1 initialization
; 0000 0043 // Clock source: System Clock
; 0000 0044 // Clock value: Timer 1 Stopped
; 0000 0045 // Mode: Normal top=FFFFh
; 0000 0046 // OC1A output: Discon.
; 0000 0047 // OC1B output: Discon.
; 0000 0048 // Noise Canceler: Off
; 0000 0049 // Input Capture on Falling Edge
; 0000 004A // Timer 1 Overflow Interrupt: Off
; 0000 004B // Input Capture Interrupt: Off
; 0000 004C // Compare A Match Interrupt: Off
; 0000 004D // Compare B Match Interrupt: Off
; 0000 004E TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 004F TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0050 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0051 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0052 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0053 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0054 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0055 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0056 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0057 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0058 
; 0000 0059 // Timer/Counter 2 initialization
; 0000 005A // Clock source: System Clock
; 0000 005B // Clock value: Timer 2 Stopped
; 0000 005C // Mode: Normal top=FFh
; 0000 005D // OC2 output: Disconnected
; 0000 005E ASSR=0x00;
	OUT  0x22,R30
; 0000 005F TCCR2=0x00;
	OUT  0x25,R30
; 0000 0060 TCNT2=0x00;
	OUT  0x24,R30
; 0000 0061 OCR2=0x00;
	OUT  0x23,R30
; 0000 0062 
; 0000 0063 // External Interrupt(s) initialization
; 0000 0064 // INT0: Off
; 0000 0065 // INT1: Off
; 0000 0066 // INT2: Off
; 0000 0067 MCUCR=0x00;
	OUT  0x35,R30
; 0000 0068 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 0069 
; 0000 006A // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 006B TIMSK=0x00;
	OUT  0x39,R30
; 0000 006C 
; 0000 006D // Analog Comparator initialization
; 0000 006E // Analog Comparator: Off
; 0000 006F // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0070 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0071 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0072 
; 0000 0073 while (1)
; 0000 0074       {
; 0000 0075 DDRA=0x1F;//80
	LDI  R30,LOW(31)
	OUT  0x1A,R30
; 0000 0076 PORTA=0x0F;
	LDI  R30,LOW(15)
	OUT  0x1B,R30
; 0000 0077 delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0078 start:
_0x6:
; 0000 0079 DDRA=0x13;//42
	RCALL SUBOPT_0x0
; 0000 007A PORTA=0x02;
; 0000 007B delay_us(1);
; 0000 007C DDRA=0x10;//40
	RCALL SUBOPT_0x1
; 0000 007D PORTA=0x00;
; 0000 007E delay_us(1);
; 0000 007F DDRA=0x11;//39
; 0000 0080 PORTA=0x00;
	RCALL SUBOPT_0x2
; 0000 0081 delay_us(2);
; 0000 0082 DDRA=0x13;//38
; 0000 0083 PORTA=0x01;
	RCALL SUBOPT_0x3
; 0000 0084 delay_us(1);
; 0000 0085 DDRA=0x12;//37
	LDI  R30,LOW(18)
	OUT  0x1A,R30
; 0000 0086 PORTA=0x00;
	RCALL SUBOPT_0x2
; 0000 0087 delay_us(2);
; 0000 0088 DDRA=0x13;//36
; 0000 0089 PORTA=0x00;
	RCALL SUBOPT_0x4
; 0000 008A delay_us(1);
; 0000 008B DDRA=0x17;//35
	RCALL SUBOPT_0x5
; 0000 008C PORTA=0x03;
; 0000 008D delay_us(1);
; 0000 008E DDRA=0x16;//34
	RCALL SUBOPT_0x6
; 0000 008F PORTA=0x02;
; 0000 0090 delay_us(2);
; 0000 0091 DDRA=0x17;//33
	RCALL SUBOPT_0x7
; 0000 0092 PORTA=0x02;
; 0000 0093 delay_us(1);
; 0000 0094 DDRA=0x15;//32
	RCALL SUBOPT_0x8
; 0000 0095 PORTA=0x01;
; 0000 0096 delay_us(2);
; 0000 0097 DDRA=0x14;//31
	LDI  R30,LOW(20)
	OUT  0x1A,R30
; 0000 0098 PORTA=0x00;
	RCALL SUBOPT_0x4
; 0000 0099 delay_us(1);
; 0000 009A DDRA=0x15;//30
	RCALL SUBOPT_0x9
; 0000 009B PORTA=0x00;
; 0000 009C delay_us(2);
; 0000 009D DDRA=0x17;//29
	LDI  R30,LOW(23)
	OUT  0x1A,R30
; 0000 009E PORTA=0x01;
	RCALL SUBOPT_0x3
; 0000 009F delay_us(1);
; 0000 00A0 DDRA=0x16;//28
	RCALL SUBOPT_0xA
; 0000 00A1 PORTA=0x00;
; 0000 00A2 delay_us(2);
; 0000 00A3 DDRA=0x17;//27
; 0000 00A4 PORTA=0x00;
	RCALL SUBOPT_0x4
; 0000 00A5 delay_us(1);
; 0000 00A6 DDRA=0x1F;//26
	RCALL SUBOPT_0xB
; 0000 00A7 PORTA=0x07;
; 0000 00A8 delay_us(2);
; 0000 00A9 DDRA=0x1E;//25
	RCALL SUBOPT_0xC
; 0000 00AA PORTA=0x06;
; 0000 00AB delay_us(1);
; 0000 00AC DDRA=0x1F;//24
	RCALL SUBOPT_0xD
; 0000 00AD PORTA=0x06;
; 0000 00AE delay_us(2);
; 0000 00AF DDRA=0x1D;//23
	RCALL SUBOPT_0xE
; 0000 00B0 PORTA=0x05;
; 0000 00B1 delay_us(1);
; 0000 00B2 DDRA=0x1C;//22
	RCALL SUBOPT_0xF
; 0000 00B3 PORTA=0x04;
; 0000 00B4 delay_us(2);
; 0000 00B5 DDRA=0x1D;//21
	RCALL SUBOPT_0x10
; 0000 00B6 PORTA=0x04;
; 0000 00B7 delay_us(2);
; 0000 00B8 DDRA=0x1F;//20
	RCALL SUBOPT_0x11
; 0000 00B9 PORTA=0x05;
; 0000 00BA delay_us(1);
; 0000 00BB DDRA=0x1E;//19
	RCALL SUBOPT_0x12
; 0000 00BC PORTA=0x04;
; 0000 00BD delay_us(2);
; 0000 00BE DDRA=0x1F;//18
	RCALL SUBOPT_0x13
; 0000 00BF PORTA=0x04;
; 0000 00C0 delay_us(2);
; 0000 00C1 DDRA=0x1B;//17
	RCALL SUBOPT_0x14
; 0000 00C2 PORTA=0x03;
; 0000 00C3 delay_us(1);
; 0000 00C4 DDRA=0x1A;//16
	RCALL SUBOPT_0x15
; 0000 00C5 PORTA=0x02;
; 0000 00C6 delay_us(2);
; 0000 00C7 DDRA=0x1B;//15
	RCALL SUBOPT_0x16
; 0000 00C8 PORTA=0x02;
; 0000 00C9 delay_us(2);
; 0000 00CA DDRA=0x19;//14
	RCALL SUBOPT_0x17
; 0000 00CB PORTA=0x01;
; 0000 00CC delay_us(2);
; 0000 00CD DDRA=0x18;//13
	RCALL SUBOPT_0x18
; 0000 00CE PORTA=0x00;
; 0000 00CF delay_us(2);
; 0000 00D0 DDRA=0x19;//12
	RCALL SUBOPT_0x19
; 0000 00D1 PORTA=0x00;
; 0000 00D2 delay_us(2);
; 0000 00D3 DDRA=0x1B;//11
	RCALL SUBOPT_0x1A
; 0000 00D4 PORTA=0x01;
; 0000 00D5 delay_us(2);
; 0000 00D6 DDRA=0x1A;//10
	RCALL SUBOPT_0x1B
; 0000 00D7 PORTA=0x00;
; 0000 00D8 delay_us(2);
; 0000 00D9 DDRA=0x1B;//9
	RCALL SUBOPT_0x1C
; 0000 00DA PORTA=0x00;
; 0000 00DB delay_us(2);
; 0000 00DC DDRA=0x1F;//8
	RCALL SUBOPT_0x1D
; 0000 00DD PORTA=0x03;
; 0000 00DE delay_us(3);
; 0000 00DF DDRA=0x1E;//7
	RCALL SUBOPT_0x1E
; 0000 00E0 PORTA=0x02;
; 0000 00E1 delay_us(2);
; 0000 00E2 DDRA=0x1F;//6
	RCALL SUBOPT_0x1F
; 0000 00E3 PORTA=0x02;
; 0000 00E4 delay_us(3);
; 0000 00E5 DDRA=0x1D;//5
	RCALL SUBOPT_0x20
; 0000 00E6 PORTA=0x01;
; 0000 00E7 delay_us(3);
; 0000 00E8 DDRA=0x1C;//4
	RCALL SUBOPT_0x21
; 0000 00E9 PORTA=0x00;
; 0000 00EA delay_us(3);
; 0000 00EB DDRA=0x1D;//3
	RCALL SUBOPT_0x22
; 0000 00EC PORTA=0x00;
; 0000 00ED delay_us(4);
; 0000 00EE DDRA=0x1F;//2
	RCALL SUBOPT_0x23
; 0000 00EF PORTA=0x01;
; 0000 00F0 delay_us(5);
; 0000 00F1 DDRA=0x1E;//1
	RCALL SUBOPT_0x24
; 0000 00F2 PORTA=0x00;
; 0000 00F3 delay_us(6);
; 0000 00F4 DDRA=0x1F;//0
	LDI  R30,LOW(31)
	OUT  0x1A,R30
; 0000 00F5 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 00F6 delay_us(19);
	__DELAY_USB 25
; 0000 00F7 DDRA=0x1E;//1
	RCALL SUBOPT_0x24
; 0000 00F8 PORTA=0x00;
; 0000 00F9 delay_us(6);
; 0000 00FA DDRA=0x1F;//2
	RCALL SUBOPT_0x23
; 0000 00FB PORTA=0x01;
; 0000 00FC delay_us(5);
; 0000 00FD DDRA=0x1D;//3
	RCALL SUBOPT_0x22
; 0000 00FE PORTA=0x00;
; 0000 00FF delay_us(4);
; 0000 0100 DDRA=0x1C;//4
	RCALL SUBOPT_0x21
; 0000 0101 PORTA=0x00;
; 0000 0102 delay_us(3);
; 0000 0103 DDRA=0x1D;//5
	RCALL SUBOPT_0x20
; 0000 0104 PORTA=0x01;
; 0000 0105 delay_us(3);
; 0000 0106 DDRA=0x1F;//6
	RCALL SUBOPT_0x1F
; 0000 0107 PORTA=0x02;
; 0000 0108 delay_us(3);
; 0000 0109 DDRA=0x1E;//7
	RCALL SUBOPT_0x1E
; 0000 010A PORTA=0x02;
; 0000 010B delay_us(2);
; 0000 010C DDRA=0x1F;//8
	RCALL SUBOPT_0x1D
; 0000 010D PORTA=0x03;
; 0000 010E delay_us(3);
; 0000 010F DDRA=0x1B;//9
	RCALL SUBOPT_0x1C
; 0000 0110 PORTA=0x00;
; 0000 0111 delay_us(2);
; 0000 0112 DDRA=0x1A;//10
	RCALL SUBOPT_0x1B
; 0000 0113 PORTA=0x00;
; 0000 0114 delay_us(2);
; 0000 0115 DDRA=0x1B;//11
	RCALL SUBOPT_0x1A
; 0000 0116 PORTA=0x01;
; 0000 0117 delay_us(2);
; 0000 0118 DDRA=0x19;//12
	RCALL SUBOPT_0x19
; 0000 0119 PORTA=0x00;
; 0000 011A delay_us(2);
; 0000 011B DDRA=0x18;//13
	RCALL SUBOPT_0x18
; 0000 011C PORTA=0x00;
; 0000 011D delay_us(2);
; 0000 011E DDRA=0x19;//14
	RCALL SUBOPT_0x17
; 0000 011F PORTA=0x01;
; 0000 0120 delay_us(2);
; 0000 0121 DDRA=0x1B;//15
	RCALL SUBOPT_0x16
; 0000 0122 PORTA=0x02;
; 0000 0123 delay_us(2);
; 0000 0124 DDRA=0x1A;//16
	RCALL SUBOPT_0x15
; 0000 0125 PORTA=0x02;
; 0000 0126 delay_us(2);
; 0000 0127 DDRA=0x1B;//17
	RCALL SUBOPT_0x14
; 0000 0128 PORTA=0x03;
; 0000 0129 delay_us(1);
; 0000 012A DDRA=0x1F;//18
	RCALL SUBOPT_0x13
; 0000 012B PORTA=0x04;
; 0000 012C delay_us(2);
; 0000 012D DDRA=0x1E;//19
	RCALL SUBOPT_0x12
; 0000 012E PORTA=0x04;
; 0000 012F delay_us(2);
; 0000 0130 DDRA=0x1F;//20
	RCALL SUBOPT_0x11
; 0000 0131 PORTA=0x05;
; 0000 0132 delay_us(1);
; 0000 0133 DDRA=0x1D;//21
	RCALL SUBOPT_0x10
; 0000 0134 PORTA=0x04;
; 0000 0135 delay_us(2);
; 0000 0136 DDRA=0x1C;//22
	RCALL SUBOPT_0xF
; 0000 0137 PORTA=0x04;
; 0000 0138 delay_us(2);
; 0000 0139 DDRA=0x1D;//23
	RCALL SUBOPT_0xE
; 0000 013A PORTA=0x05;
; 0000 013B delay_us(1);
; 0000 013C DDRA=0x1F;//24
	RCALL SUBOPT_0xD
; 0000 013D PORTA=0x06;
; 0000 013E delay_us(2);
; 0000 013F DDRA=0x1E;//25
	RCALL SUBOPT_0xC
; 0000 0140 PORTA=0x06;
; 0000 0141 delay_us(1);
; 0000 0142 DDRA=0x1F;//26
	RCALL SUBOPT_0xB
; 0000 0143 PORTA=0x07;
; 0000 0144 delay_us(2);
; 0000 0145 DDRA=0x17;//27
	LDI  R30,LOW(23)
	OUT  0x1A,R30
; 0000 0146 PORTA=0x00;
	RCALL SUBOPT_0x4
; 0000 0147 delay_us(1);
; 0000 0148 DDRA=0x16;//28
	RCALL SUBOPT_0xA
; 0000 0149 PORTA=0x00;
; 0000 014A delay_us(2);
; 0000 014B DDRA=0x17;//29
; 0000 014C PORTA=0x01;
	RCALL SUBOPT_0x3
; 0000 014D delay_us(1);
; 0000 014E DDRA=0x15;//30
	RCALL SUBOPT_0x9
; 0000 014F PORTA=0x00;
; 0000 0150 delay_us(2);
; 0000 0151 DDRA=0x14;//31
	LDI  R30,LOW(20)
	OUT  0x1A,R30
; 0000 0152 PORTA=0x00;
	RCALL SUBOPT_0x4
; 0000 0153 delay_us(1);
; 0000 0154 DDRA=0x15;//32
	RCALL SUBOPT_0x8
; 0000 0155 PORTA=0x01;
; 0000 0156 delay_us(2);
; 0000 0157 DDRA=0x17;//33
	RCALL SUBOPT_0x7
; 0000 0158 PORTA=0x02;
; 0000 0159 delay_us(1);
; 0000 015A DDRA=0x16;//34
	RCALL SUBOPT_0x6
; 0000 015B PORTA=0x02;
; 0000 015C delay_us(2);
; 0000 015D DDRA=0x17;//35
	RCALL SUBOPT_0x5
; 0000 015E PORTA=0x03;
; 0000 015F delay_us(1);
; 0000 0160 DDRA=0x13;//36
	LDI  R30,LOW(19)
	OUT  0x1A,R30
; 0000 0161 PORTA=0x00;
	RCALL SUBOPT_0x4
; 0000 0162 delay_us(1);
; 0000 0163 DDRA=0x12;//37
	LDI  R30,LOW(18)
	OUT  0x1A,R30
; 0000 0164 PORTA=0x00;
	RCALL SUBOPT_0x2
; 0000 0165 delay_us(2);
; 0000 0166 DDRA=0x13;//38
; 0000 0167 PORTA=0x01;
	RCALL SUBOPT_0x3
; 0000 0168 delay_us(1);
; 0000 0169 DDRA=0x11;//39
	LDI  R30,LOW(17)
	OUT  0x1A,R30
; 0000 016A PORTA=0x00;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x25
; 0000 016B delay_us(2);
; 0000 016C DDRA=0x10;//40
	RCALL SUBOPT_0x1
; 0000 016D PORTA=0x00;
; 0000 016E delay_us(1);
; 0000 016F DDRA=0x11;//41
; 0000 0170 PORTA=0x01;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x25
; 0000 0171 delay_us(2);
; 0000 0172 DDRA=0x13;//42
	RCALL SUBOPT_0x0
; 0000 0173 PORTA=0x02;
; 0000 0174 delay_us(1);
; 0000 0175 DDRA=0x12;//43
	LDI  R30,LOW(18)
	OUT  0x1A,R30
; 0000 0176 PORTA=0x02;
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x25
; 0000 0177 delay_us(2);
; 0000 0178 DDRA=0x13;//44
	RCALL SUBOPT_0x26
; 0000 0179 PORTA=0x03;
; 0000 017A delay_us(1);
; 0000 017B DDRA=0x17;//45
	RCALL SUBOPT_0x27
; 0000 017C PORTA=0x04;
; 0000 017D delay_us(1);
; 0000 017E DDRA=0x16;//46
	LDI  R30,LOW(22)
	RCALL SUBOPT_0x28
; 0000 017F PORTA=0x04;
; 0000 0180 delay_us(2);
; 0000 0181 DDRA=0x17;//47
	RCALL SUBOPT_0x29
; 0000 0182 PORTA=0x05;
; 0000 0183 delay_us(1);
; 0000 0184 DDRA=0x15;//48
	LDI  R30,LOW(21)
	RCALL SUBOPT_0x28
; 0000 0185 PORTA=0x04;
; 0000 0186 delay_us(2);
; 0000 0187 DDRA=0x14;//49
	RCALL SUBOPT_0x2A
; 0000 0188 PORTA=0x04;
; 0000 0189 delay_us(1);
; 0000 018A DDRA=0x15;//50
	OUT  0x1A,R30
; 0000 018B PORTA=0x05;
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x25
; 0000 018C delay_us(2);
; 0000 018D DDRA=0x17;//51
	RCALL SUBOPT_0x2B
; 0000 018E PORTA=0x06;
; 0000 018F delay_us(1);
; 0000 0190 DDRA=0x16;//52
	LDI  R30,LOW(22)
	OUT  0x1A,R30
; 0000 0191 PORTA=0x06;
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x25
; 0000 0192 delay_us(2);
; 0000 0193 DDRA=0x17;//53
	RCALL SUBOPT_0x2C
; 0000 0194 PORTA=0x07;
; 0000 0195 delay_us(1);
; 0000 0196 DDRA=0x1F;//54
	LDI  R30,LOW(31)
	RCALL SUBOPT_0x2D
; 0000 0197 PORTA=0x08;
; 0000 0198 delay_us(2);
; 0000 0199 DDRA=0x1E;//55
	RCALL SUBOPT_0x2E
; 0000 019A PORTA=0x08;
; 0000 019B delay_us(1);
; 0000 019C DDRA=0x1F;//56
	RCALL SUBOPT_0x2F
; 0000 019D PORTA=0x09;
; 0000 019E delay_us(2);
; 0000 019F DDRA=0x1D;//57
	RCALL SUBOPT_0x30
; 0000 01A0 PORTA=0x08;
; 0000 01A1 delay_us(1);
; 0000 01A2 DDRA=0x1C;//58
	LDI  R30,LOW(28)
	RCALL SUBOPT_0x2D
; 0000 01A3 PORTA=0x08;
; 0000 01A4 delay_us(2);
; 0000 01A5 DDRA=0x1D;//59
	LDI  R30,LOW(29)
	RCALL SUBOPT_0x2F
; 0000 01A6 PORTA=0x09;
; 0000 01A7 delay_us(2);
; 0000 01A8 DDRA=0x1F;//60
	RCALL SUBOPT_0x31
; 0000 01A9 PORTA=0x0A;
; 0000 01AA delay_us(1);
; 0000 01AB DDRA=0x1E;//61
	LDI  R30,LOW(30)
	RCALL SUBOPT_0x32
; 0000 01AC PORTA=0x0A;
; 0000 01AD delay_us(2);
; 0000 01AE DDRA=0x1F;//62
	LDI  R30,LOW(31)
	RCALL SUBOPT_0x33
; 0000 01AF PORTA=0x0B;
; 0000 01B0 delay_us(2);
; 0000 01B1 DDRA=0x1B;//63
	RCALL SUBOPT_0x34
; 0000 01B2 PORTA=0x08;
; 0000 01B3 delay_us(1);
; 0000 01B4 DDRA=0x1A;//64
	LDI  R30,LOW(26)
	RCALL SUBOPT_0x2D
; 0000 01B5 PORTA=0x08;
; 0000 01B6 delay_us(2);
; 0000 01B7 DDRA=0x1B;//65
	LDI  R30,LOW(27)
	RCALL SUBOPT_0x2F
; 0000 01B8 PORTA=0x09;
; 0000 01B9 delay_us(2);
; 0000 01BA DDRA=0x19;//66
	LDI  R30,LOW(25)
	RCALL SUBOPT_0x2D
; 0000 01BB PORTA=0x08;
; 0000 01BC delay_us(2);
; 0000 01BD DDRA=0x18;//67
	LDI  R30,LOW(24)
	RCALL SUBOPT_0x2D
; 0000 01BE PORTA=0x08;
; 0000 01BF delay_us(2);
; 0000 01C0 DDRA=0x19;//68
	LDI  R30,LOW(25)
	RCALL SUBOPT_0x2F
; 0000 01C1 PORTA=0x09;
; 0000 01C2 delay_us(2);
; 0000 01C3 DDRA=0x1B;//69
	LDI  R30,LOW(27)
	RCALL SUBOPT_0x32
; 0000 01C4 PORTA=0x0A;
; 0000 01C5 delay_us(2);
; 0000 01C6 DDRA=0x1A;//70
	LDI  R30,LOW(26)
	RCALL SUBOPT_0x32
; 0000 01C7 PORTA=0x0A;
; 0000 01C8 delay_us(2);
; 0000 01C9 DDRA=0x1B;//71
	LDI  R30,LOW(27)
	RCALL SUBOPT_0x33
; 0000 01CA PORTA=0x0B;
; 0000 01CB delay_us(2);
; 0000 01CC DDRA=0x1F;//72
	RCALL SUBOPT_0x35
; 0000 01CD PORTA=0x0C;
; 0000 01CE delay_us(3);
; 0000 01CF DDRA=0x1E;//73
	LDI  R30,LOW(30)
	OUT  0x1A,R30
; 0000 01D0 PORTA=0x0C;
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x25
; 0000 01D1 delay_us(2);
; 0000 01D2 DDRA=0x1F;//74
	RCALL SUBOPT_0x36
; 0000 01D3 PORTA=0x0D;
; 0000 01D4 delay_us(3);
; 0000 01D5 DDRA=0x1D;//75
	RCALL SUBOPT_0x37
; 0000 01D6 PORTA=0x0C;
; 0000 01D7 delay_us(3);
; 0000 01D8 DDRA=0x1C;//76
	RCALL SUBOPT_0x38
; 0000 01D9 PORTA=0x0C;
; 0000 01DA delay_us(3);
; 0000 01DB DDRA=0x1D;//77
	RCALL SUBOPT_0x39
; 0000 01DC PORTA=0x0D;
; 0000 01DD delay_us(4);
; 0000 01DE DDRA=0x1F;//78
	RCALL SUBOPT_0x3A
; 0000 01DF PORTA=0x0E;
; 0000 01E0 delay_us(5);
; 0000 01E1 DDRA=0x1E;//79
	RCALL SUBOPT_0x3B
; 0000 01E2 PORTA=0x0E;
; 0000 01E3 delay_us(6);
; 0000 01E4 DDRA=0x1F;//80
	LDI  R30,LOW(31)
	OUT  0x1A,R30
; 0000 01E5 PORTA=0x0F;
	LDI  R30,LOW(15)
	OUT  0x1B,R30
; 0000 01E6 delay_us(19);
	__DELAY_USB 25
; 0000 01E7 DDRA=0x1E;//79
	RCALL SUBOPT_0x3B
; 0000 01E8 PORTA=0x0E;
; 0000 01E9 delay_us(6);
; 0000 01EA DDRA=0x1F;//78
	RCALL SUBOPT_0x3A
; 0000 01EB PORTA=0x0E;
; 0000 01EC delay_us(5);
; 0000 01ED DDRA=0x1D;//77
	RCALL SUBOPT_0x39
; 0000 01EE PORTA=0x0D;
; 0000 01EF delay_us(4);
; 0000 01F0 DDRA=0x1C;//76
	RCALL SUBOPT_0x38
; 0000 01F1 PORTA=0x0C;
; 0000 01F2 delay_us(3);
; 0000 01F3 DDRA=0x1D;//75
	RCALL SUBOPT_0x37
; 0000 01F4 PORTA=0x0C;
; 0000 01F5 delay_us(3);
; 0000 01F6 DDRA=0x1F;//74
	RCALL SUBOPT_0x36
; 0000 01F7 PORTA=0x0D;
; 0000 01F8 delay_us(3);
; 0000 01F9 DDRA=0x1E;//73
	LDI  R30,LOW(30)
	OUT  0x1A,R30
; 0000 01FA PORTA=0x0C;
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x25
; 0000 01FB delay_us(2);
; 0000 01FC DDRA=0x1F;//72
	RCALL SUBOPT_0x35
; 0000 01FD PORTA=0x0C;
; 0000 01FE delay_us(3);
; 0000 01FF DDRA=0x1B;//71
	LDI  R30,LOW(27)
	RCALL SUBOPT_0x33
; 0000 0200 PORTA=0x0B;
; 0000 0201 delay_us(2);
; 0000 0202 DDRA=0x1A;//70
	LDI  R30,LOW(26)
	RCALL SUBOPT_0x32
; 0000 0203 PORTA=0x0A;
; 0000 0204 delay_us(2);
; 0000 0205 DDRA=0x1B;//69
	LDI  R30,LOW(27)
	RCALL SUBOPT_0x32
; 0000 0206 PORTA=0x0A;
; 0000 0207 delay_us(2);
; 0000 0208 DDRA=0x19;//68
	LDI  R30,LOW(25)
	RCALL SUBOPT_0x2F
; 0000 0209 PORTA=0x09;
; 0000 020A delay_us(2);
; 0000 020B DDRA=0x18;//67
	LDI  R30,LOW(24)
	RCALL SUBOPT_0x2D
; 0000 020C PORTA=0x08;
; 0000 020D delay_us(2);
; 0000 020E DDRA=0x19;//66
	LDI  R30,LOW(25)
	RCALL SUBOPT_0x2D
; 0000 020F PORTA=0x08;
; 0000 0210 delay_us(2);
; 0000 0211 DDRA=0x1B;//65
	LDI  R30,LOW(27)
	RCALL SUBOPT_0x2F
; 0000 0212 PORTA=0x09;
; 0000 0213 delay_us(2);
; 0000 0214 DDRA=0x1A;//64
	LDI  R30,LOW(26)
	RCALL SUBOPT_0x2D
; 0000 0215 PORTA=0x08;
; 0000 0216 delay_us(2);
; 0000 0217 DDRA=0x1B;//63
	RCALL SUBOPT_0x34
; 0000 0218 PORTA=0x08;
; 0000 0219 delay_us(1);
; 0000 021A DDRA=0x1F;//62
	LDI  R30,LOW(31)
	RCALL SUBOPT_0x33
; 0000 021B PORTA=0x0B;
; 0000 021C delay_us(2);
; 0000 021D DDRA=0x1E;//61
	LDI  R30,LOW(30)
	RCALL SUBOPT_0x32
; 0000 021E PORTA=0x0A;
; 0000 021F delay_us(2);
; 0000 0220 DDRA=0x1F;//60
	RCALL SUBOPT_0x31
; 0000 0221 PORTA=0x0A;
; 0000 0222 delay_us(1);
; 0000 0223 DDRA=0x1D;//59
	LDI  R30,LOW(29)
	RCALL SUBOPT_0x2F
; 0000 0224 PORTA=0x09;
; 0000 0225 delay_us(2);
; 0000 0226 DDRA=0x1C;//58
	LDI  R30,LOW(28)
	RCALL SUBOPT_0x2D
; 0000 0227 PORTA=0x08;
; 0000 0228 delay_us(2);
; 0000 0229 DDRA=0x1D;//57
	RCALL SUBOPT_0x30
; 0000 022A PORTA=0x08;
; 0000 022B delay_us(1);
; 0000 022C DDRA=0x1F;//56
	LDI  R30,LOW(31)
	RCALL SUBOPT_0x2F
; 0000 022D PORTA=0x09;
; 0000 022E delay_us(2);
; 0000 022F DDRA=0x1E;//55
	RCALL SUBOPT_0x2E
; 0000 0230 PORTA=0x08;
; 0000 0231 delay_us(1);
; 0000 0232 DDRA=0x1F;//54
	RCALL SUBOPT_0x2D
; 0000 0233 PORTA=0x08;
; 0000 0234 delay_us(2);
; 0000 0235 DDRA=0x17;//53
	RCALL SUBOPT_0x2C
; 0000 0236 PORTA=0x07;
; 0000 0237 delay_us(1);
; 0000 0238 DDRA=0x16;//52
	LDI  R30,LOW(22)
	OUT  0x1A,R30
; 0000 0239 PORTA=0x06;
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x25
; 0000 023A delay_us(2);
; 0000 023B DDRA=0x17;//51
	RCALL SUBOPT_0x2B
; 0000 023C PORTA=0x06;
; 0000 023D delay_us(1);
; 0000 023E DDRA=0x15;//50
	LDI  R30,LOW(21)
	OUT  0x1A,R30
; 0000 023F PORTA=0x05;
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x25
; 0000 0240 delay_us(2);
; 0000 0241 DDRA=0x14;//49
	RCALL SUBOPT_0x2A
; 0000 0242 PORTA=0x04;
; 0000 0243 delay_us(1);
; 0000 0244 DDRA=0x15;//48
	RCALL SUBOPT_0x28
; 0000 0245 PORTA=0x04;
; 0000 0246 delay_us(2);
; 0000 0247 DDRA=0x17;//47
	RCALL SUBOPT_0x29
; 0000 0248 PORTA=0x05;
; 0000 0249 delay_us(1);
; 0000 024A DDRA=0x16;//46
	LDI  R30,LOW(22)
	RCALL SUBOPT_0x28
; 0000 024B PORTA=0x04;
; 0000 024C delay_us(2);
; 0000 024D DDRA=0x17;//45
	RCALL SUBOPT_0x27
; 0000 024E PORTA=0x04;
; 0000 024F delay_us(1);
; 0000 0250 DDRA=0x13;//44
	RCALL SUBOPT_0x26
; 0000 0251 PORTA=0x03;
; 0000 0252 delay_us(1);
; 0000 0253 DDRA=0x12;//43
	LDI  R30,LOW(18)
	OUT  0x1A,R30
; 0000 0254 PORTA=0x02;
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x25
; 0000 0255 delay_us(2);
; 0000 0256 DDRA=0x13;//42
	RCALL SUBOPT_0x0
; 0000 0257 PORTA=0x02;
; 0000 0258 delay_us(1);
; 0000 0259 DDRA=0x11;//41
	LDI  R30,LOW(17)
	OUT  0x1A,R30
; 0000 025A PORTA=0x01;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x25
; 0000 025B delay_us(2);
; 0000 025C DDRA=0x10;//40
	LDI  R30,LOW(16)
	OUT  0x1A,R30
; 0000 025D PORTA=0x00;
	RCALL SUBOPT_0x4
; 0000 025E delay_us(1);
; 0000 025F goto start;
	RJMP _0x6
; 0000 0260       };
; 0000 0261 }
_0x7:
	RJMP _0x7

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(19)
	OUT  0x1A,R30
	LDI  R30,LOW(2)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(16)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 1
	LDI  R30,LOW(17)
	OUT  0x1A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 3
	LDI  R30,LOW(19)
	OUT  0x1A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(1)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(23)
	OUT  0x1A,R30
	LDI  R30,LOW(3)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(22)
	OUT  0x1A,R30
	LDI  R30,LOW(2)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(23)
	OUT  0x1A,R30
	LDI  R30,LOW(2)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(21)
	OUT  0x1A,R30
	LDI  R30,LOW(1)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(21)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(22)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 3
	LDI  R30,LOW(23)
	OUT  0x1A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(7)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(30)
	OUT  0x1A,R30
	LDI  R30,LOW(6)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(6)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(29)
	OUT  0x1A,R30
	LDI  R30,LOW(5)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(28)
	OUT  0x1A,R30
	LDI  R30,LOW(4)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(29)
	OUT  0x1A,R30
	LDI  R30,LOW(4)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(5)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(30)
	OUT  0x1A,R30
	LDI  R30,LOW(4)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(4)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(27)
	OUT  0x1A,R30
	LDI  R30,LOW(3)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(26)
	OUT  0x1A,R30
	LDI  R30,LOW(2)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(27)
	OUT  0x1A,R30
	LDI  R30,LOW(2)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(25)
	OUT  0x1A,R30
	LDI  R30,LOW(1)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(24)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(25)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(27)
	OUT  0x1A,R30
	LDI  R30,LOW(1)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(26)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(27)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(3)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(30)
	OUT  0x1A,R30
	LDI  R30,LOW(2)
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(2)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x20:
	LDI  R30,LOW(29)
	OUT  0x1A,R30
	LDI  R30,LOW(1)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(28)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(29)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x23:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(1)
	OUT  0x1B,R30
	__DELAY_USB 7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	LDI  R30,LOW(30)
	OUT  0x1A,R30
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	__DELAY_USB 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 43 TIMES, CODE SIZE REDUCTION:81 WORDS
SUBOPT_0x25:
	OUT  0x1B,R30
	__DELAY_USB 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(19)
	OUT  0x1A,R30
	LDI  R30,LOW(3)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x27:
	LDI  R30,LOW(23)
	OUT  0x1A,R30
	LDI  R30,LOW(4)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	OUT  0x1A,R30
	LDI  R30,LOW(4)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x29:
	LDI  R30,LOW(23)
	OUT  0x1A,R30
	LDI  R30,LOW(5)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(20)
	OUT  0x1A,R30
	LDI  R30,LOW(4)
	OUT  0x1B,R30
	__DELAY_USB 1
	LDI  R30,LOW(21)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(23)
	OUT  0x1A,R30
	LDI  R30,LOW(6)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2C:
	LDI  R30,LOW(23)
	OUT  0x1A,R30
	LDI  R30,LOW(7)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x2D:
	OUT  0x1A,R30
	LDI  R30,LOW(8)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(30)
	OUT  0x1A,R30
	LDI  R30,LOW(8)
	OUT  0x1B,R30
	__DELAY_USB 1
	LDI  R30,LOW(31)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x2F:
	OUT  0x1A,R30
	LDI  R30,LOW(9)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x30:
	LDI  R30,LOW(29)
	OUT  0x1A,R30
	LDI  R30,LOW(8)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x31:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(10)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x32:
	OUT  0x1A,R30
	LDI  R30,LOW(10)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	OUT  0x1A,R30
	LDI  R30,LOW(11)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x34:
	LDI  R30,LOW(27)
	OUT  0x1A,R30
	LDI  R30,LOW(8)
	OUT  0x1B,R30
	__DELAY_USB 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x35:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(12)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x36:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(13)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x37:
	LDI  R30,LOW(29)
	OUT  0x1A,R30
	LDI  R30,LOW(12)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x38:
	LDI  R30,LOW(28)
	OUT  0x1A,R30
	LDI  R30,LOW(12)
	OUT  0x1B,R30
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x39:
	LDI  R30,LOW(29)
	OUT  0x1A,R30
	LDI  R30,LOW(13)
	OUT  0x1B,R30
	__DELAY_USB 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3A:
	LDI  R30,LOW(31)
	OUT  0x1A,R30
	LDI  R30,LOW(14)
	OUT  0x1B,R30
	__DELAY_USB 7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3B:
	LDI  R30,LOW(30)
	OUT  0x1A,R30
	LDI  R30,LOW(14)
	OUT  0x1B,R30
	__DELAY_USB 8
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
